{
| This code uses the Buffer PIC to Program
| the 16F84 and 16F877 PIC chips.
| Currently, the PIC16F877 requires the use
| of the command $18,No erase and Program.
}


unit ppdelp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus,
{
  pic_prog_delph, CommDrv, ExtCtrls, Buttons, IniFiles,Registry, CommDrv2;
}
  pic_prog_delph, ExtCtrls, Buttons, IniFiles,Registry, CommDrv,  pic_prog_About ;


type
  TForm1 = class(TForm)
    Label1:            TLabel;
    MProg:             TMemo;
    Label2:            TLabel;
    MData:             TMemo;
    Label3:            TLabel;
    MFuses: TMemo;
    MainMenu1: TMainMenu;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    Label4: TLabel;
    SaveDialog1: TSaveDialog;
    Label5: TLabel;
    File2: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    SaveAs2: TMenuItem;
    Save3: TMenuItem;
    Open2: TMenuItem;
    New1: TMenuItem;
    Edit2: TMenuItem;
    Object2: TMenuItem;
    Links2: TMenuItem;
    N8: TMenuItem;
    GoTo2: TMenuItem;
    Replace2: TMenuItem;
    Find2: TMenuItem;
    N9: TMenuItem;
    PasteSpecial2: TMenuItem;
    Paste2: TMenuItem;
    Copy2: TMenuItem;
    Cut2: TMenuItem;
    N10: TMenuItem;
    Repeatcommand2: TMenuItem;
    Undo2: TMenuItem;
    Button5: TButton;
    Timer1: TTimer;
    Button6: TButton;
    Button7: TButton;
    BitBtn1: TBitBtn;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Label6: TLabel;
    Button11: TButton;
    Button12: TButton;
    ReopenLast1: TMenuItem;
    Button2: TButton;
    Button1: TButton;
    Button3: TButton;
    CheckBox1: TCheckBox;
    Label7: TLabel;
    Label8: TLabel;
    CommPortDriver1: TCommPortDriver;
    Label9: TLabel;
    Label10: TLabel;
    About1: TMenuItem;
    procedure Open2Click(Sender: TObject);
    procedure Save3Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure ReopenLast1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
private
    procedure processMemo;
    { Private declarations }
  public
    { Public declarations }
  end;

type
  progModeT = ( readData, readProg,readFuses,
                bulkEraseProg,bulkEraseData,
                progProg,progData,progFuses
              );

const
     LD_CONF       = $00;
     LD_PRG_MEM    = $02;
     RD_PRG_MEM    = $04;
     INC_ADDR      = $06;
     PROG          = $08;
     PROG_NO_ERASE = $18;

     PROG_STOP   = $0E;
     LD_DATA_MEM = $03;
     RD_DATA_MEM = $05;
     ERASE_PROG  = $09;
     ERASE_DATA  = $0B;
     DIS_PROTECT1= $01;
     DIS_PROTECT2= $07;

     Voff          = $20;
     Vpp           = $21;
     V5VnVpp       = $22;
     V5VVpp        = $23;
     VInvAllOff    = $24;
     VInv5V        = $25;
     VInv5VVpp     = $26;
{
     ; The XX only apply to the 16F877
;
;	Specials for turning on the +5 volts and 5 Vpp
;
;all Off			100000
;Vpp On				100001
;+5  On,Vpp Off			100010
;+5  On,Vpp On			100011
;
;

}

var
  Form1        : TForm1;
  HexData,ChipData      : HexDataT;
  chipAddress  : integer;
  state,temp   : integer;
  cnt1,cnt2    : integer;
  progMode     : progModeT;
  opStr        : string;
  dwEvtMask    : DWORD;
  Errors       : boolean;
  BlankChip    : boolean;
  ChipSame     : boolean;
  FileName     : string;
  IniFile      : TRegIniFile;
  NeedsWait       : boolean;

implementation

uses ppdelp;

{$R *.DFM}

procedure wrtCMD(cmd:integer); forward;


procedure TForm1.Open2Click(Sender: TObject);
var
   cnt, cnt2 : integer;
begin
  OpenDialog1.FileName := '*.hex';
  if OpenDialog1.Execute then
  begin
    Memo1.Lines.LoadfromFile(OpenDialog1.FileName);
    SaveDialog1.Filename := OpenDialog1.FileName;
    Caption := OpenDialog1.FileName;
    Filename := OpenDialog1.FileName;
    processMemo;
  end;
end;

procedure TForm1.Save3Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
  begin
    Memo1.Lines.LoadfromFile(OpenDialog1.FileName);
    SaveDialog1.Filename := OpenDialog1.FileName;
    Caption := OpenDialog1.FileName;
  end;

end;

{
; The Crownhill is a serial port programmer.
; TXD -> VPP and +5, To apply, Set the BREAK to apply continously
; DTR -> Data to
; RTS -> Clock
; CTS <- Data from PIC
;
;
}


{
; The Crownhill is a serial port programmer.
; TXD -> VPP and +5, To apply, Set the BREAK to apply continously
; DTR -> Data to
; RTS -> Clock
; CTS <- Data from PIC
;
;
}



{
; The Crownhill is a serial port programmer.
; TXD -> VPP and +5, To apply, Set the BREAK to apply continously
; DTR -> Data to
; RTS -> Clock
; CTS <- Data from PIC
;
;
}
procedure ConnectComPort;
begin
  Form1.CommPortDriver1.ComPort:= pnCOM1 ;
  Form1.CommPortDriver1.Connect;
  if Form1.CommPortDriver1.Connected then
  begin
    dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD;
    SetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
  end;
end;


function rdDataBit:boolean;
var
   ret : boolean;
   a : TCOMSTAT;
   dwEvtMask: DWORD;
   lpModemStat: DWORD;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD;
    ret := GetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
    ret := GetCommModemStatus(Form1.CommPortDriver1.FComPortHandle, lpModemStat);


{    Label2.caption := IntToHex( lpModemStat ,4 );  }

    rdDataBit :=  (  $0010 = ( lpModemStat and ( $0010 ) ) ) ;

  end;
end;

function rdClkOBit:boolean;
var
   ret : boolean;
   a : TCOMSTAT;
   dwEvtMask: DWORD;
   lpModemStat: DWORD;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD;
    ret := GetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
    ret := GetCommModemStatus(Form1.CommPortDriver1.FComPortHandle, lpModemStat);


{    Label2.caption := IntToHex( lpModemStat ,4 );  }

    rdClkOBit :=  (  $0020 = ( lpModemStat and ( $0020 ) ) ) ;

  end;
end;

function rdDataOBit:boolean;
var
   ret : boolean;
   a : TCOMSTAT;
   dwEvtMask: DWORD;
   lpModemStat: DWORD;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD;
    ret := GetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
    ret := GetCommModemStatus(Form1.CommPortDriver1.FComPortHandle, lpModemStat);

{    Label2.caption := IntToHex( lpModemStat ,4 );  }

    rdDataOBit :=  (  $0080 = ( lpModemStat and ( $0080 ) ) ) ;

  end;
end;



procedure setClk;{(Sender: TObject);}
var
   count : integer;
begin
  count := 0;
  if Form1.CommPortDriver1.Connected then
  begin
    EscapeCommFunction( Form1.CommPortDriver1.FComPortHandle,SETRTS);
 {
    if  ( (not rdClkOBit) AND NeedsWait ) then
    begin
       while ( ( not rdClkOBit )  )do ;
       count := count + 1;
    end;
 }
  repeat until ( rdClkOBit or NOT  NeedsWait )  ;
  end;
  Form1.Label7.caption := IntToStr( count );
end;

procedure resetClk;
var
   count : integer;
begin
  count := 0;
  if Form1.CommPortDriver1.Connected then
  begin
    EscapeCommFunction( Form1.CommPortDriver1.FComPortHandle,CLRRTS);
  {
    if  ( rdClkOBit AND NeedsWait ) then
    begin
       while ( rdClkOBit )do ;
       count := count + 1;
    end;
  }
    repeat until ( not rdClkOBit or NOT  NeedsWait )  ;

  end;
  Form1.Label8.caption := IntToStr( count );

end;

procedure setData;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    EscapeCommFunction( Form1.CommPortDriver1.FComPortHandle,SETDTR);
  end;
end;

procedure resetData;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    EscapeCommFunction( Form1.CommPortDriver1.FComPortHandle,CLRDTR);
  end;
end;


procedure setVPP;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    SetCommBreak( Form1.CommPortDriver1.FComPortHandle);
  end;
end;

procedure resetVPP;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    ClearCommBreak( Form1.CommPortDriver1.FComPortHandle);
  end;
end;


procedure Apply5VandVPP;
begin
  setVPP;
   if NeedsWait then
      wrtCmd(  $20 );
end;

procedure Apply5V;
begin
  setVPP;
  if NeedsWait then
    wrtCmd(  $22 );
end;

procedure Remove5VandVpp;
begin
 resetVPP;
 if NeedsWait then
   wrtCmd(  $23 );
end;

procedure wrtCMD(cmd:integer);
var
  cnt : byte;
begin
  { zero bits }
  resetData;
  resetClk;
  for cnt := 0 to 5 do
  BEGIN
    if 0 = ( cmd and 1 )
    then
    begin
      resetData;
    end
    else
    begin
      setData;
    end;
    setClk;
    resetClk;
    cmd := cmd shr 1 ;
  END;
  { Turn data line into input, just incase command is read }
end;

procedure wrtData(cmd:integer);
var
  cnt : byte;
begin
  { zero bits }
  cmd := cmd shl 1;
  for cnt := 0 to 15 do
  BEGIN
    if 0 = ( cmd and 1 )
    then
    begin
      resetData;
    end
    else
    begin
      setData;
    end;
    setClk;
    resetClk;
    cmd := cmd shr 1 ;
  END;
end;

function rdData:integer;
var
  cnt : byte;
  cmd : integer;
  readBit : boolean;
begin
  cmd := 0;
  resetData;
  resetClk;
  { Clock one bit }
  setClk;
  resetClk;
  for cnt := 0 to 14 do
  BEGIN
    setData; { Bias the PIC }
    setClk;
    { data is being presented }
{
    resetClk;
}
    { data should  not be present }
    if NeedsWait then
       readBit := rdDataOBit
       else
       readBit := rdDataBit;

    if not readBit
    then
    begin
      cmd := cmd shr 1 ;
    end
    else
    begin
      cmd := cmd shr 1 ;
      cmd := cmd or $4000 ;
    end;
    resetClk;
  END;
  rdData := cmd and $3FFF;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  cnt1,cnt2,temp:integer;
begin
  MProg.lines.clear;
  progMode := readProg;
  state := 1;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  finished :boolean;
 begin
     { Timer is used to pause delays }
     Label5.caption := intToStr( state );
     case state of
     1:
     { Put the chip into programme mode }
     Begin
       NeedsWait       := TRUE;
       NeedsWait       := CheckBox1.Checked;
       Remove5VandVPP;

       BlankChip    := TRUE;
       ChipSame     := TRUE;

       Form1.Cursor :=  crHourGlass;
       ConnectComPort;
       { zero bits }
       resetData;
       resetClk;
{       Apply5V; }

       state  := 3;
       Label5.caption := 'Programming...';
     end;
     3:
     Begin
       resetData;
       resetClk;
       Apply5V;
       state  := state +1;
       Label5.caption := 'Programming...';
     end;
     10:
     {
     With 5volts on Chip, bounce MCLR/VPP pin,
     Programming mode is entered if
     data and Clk = 0 when Vpp raised to 12 volts.
     Most 16F84 seems to programme well outside
     the spec.
     }
     Begin
       resetData;
       resetClk;

       Remove5VandVPP;
       state  := 11;
     end;

     11:
     {
     With 5volts on Chip, bounce MCLR/VPP pin,
     Programming mode is entered if
     data and Clk = 0 when Vpp raised to 12 volts.
     Most 16F84 seems to programme well outside
     the spec.
     }
     Begin
       resetData;
       resetClk;

       Remove5VandVPP;
       state  := 12;
     end;


     { progress with a bit of delay }
     12..19:
     Begin
       resetData;
       resetClk;
       Apply5V;
       state  := state +1;
     end;

     20:
     Begin
       resetData;
       resetClk;
       Apply5VandVPP;
       state  := state +1;
       cnt1:=0;
       cnt2:=0;
       case progMode of
           readData:       MData.lines.add('.............');
           readProg:       MProg.lines.add('.............');
           readFuses:      MFuses.lines.add('.............');
       else
       end;
       opStr  := '';
     end;

     { branch to different sections on programming mode }
     21:
     begin
       { Putting the chip into Config area needs extra instructions }
       if progMode = readFuses then
       begin
         wrtCmd(  LD_CONF );
         wrtData( $3FFF );
       end;
       state  := $4F0;
       case progMode of
         readData:  chipAddress := $2100;
         readProg:  chipAddress := $0000;
         readFuses: chipAddress := $2000;
         progProg,progData,progFuses: chipAddress := $0000;
       else
       end;

       case progMode of
         { reading from the chip }
         readData,
         readProg,
         readFuses:
         begin
           state := $40;
           {
           MFuses.Visible := False;
           MData.Visible  := False;
           MProg.Visible  := False;
           }
         end;

         { bulk erase }
         bulkEraseProg: state := $A00;
         bulkEraseData: state := $A10;

         { Program the sections of the chip }
         progProg:  state := $B00;
         progData:  state := $B04;
         progFuses: state := $B08;
       else
       end;
     end;


     30:
     begin
       case progMode of
         readData:  wrtCmd( RD_DATA_MEM  );
         readProg:  wrtCmd( RD_PRG_MEM  );
         readFuses: wrtCmd( RD_PRG_MEM  );
       else
       end;
       {wrtCmd( RD_PRG_MEM  );}

       {
        BlankChip    := TRUE;
        ChipSame     := TRUE;
       }

       temp := rdData;
       if temp <> $3FFF then BlankChip := FALSE;
       if hexData.data[ chipAddress ] <> temp then chipSame :=FALSE;

       chipData.data[ chipAddress ] := temp;
       chipAddress := chipAddress +1 ;

       wrtCmd(INC_ADDR);
       cnt1 := cnt1+1;
       opStr := opStr + ' ' + IntToHex( temp, 4 );
       if cnt1 = 8 then
       begin
         opstr := IntToHex( cnt2,4 )+' : ' + opStr;
         case progMode of
           readData:       MData.lines.add( opStr );
           readProg:       MProg.lines.add( opStr );
           readFuses:      MFuses.lines.add(opStr );
         else
         end;
         opStr := '';
         cnt2  := cnt2+8;
         cnt1  := 0;
       end;
       case progMode of
         readData:   if chipAddress = $2100 + 63 then state := $31;
         readProg:   if chipAddress = $400       then state := $31;
         readFuses:  if chipAddress = $2008      then state := $31;
       else
       end;
     end;

     $31:
     Begin
       opstr := IntToHex( cnt2,4 )+' : ' + opStr;
       case progMode of
         readData:       MData.lines.add(opStr);
         readProg:       MProg.lines.add(opStr);
         readFuses:      MFuses.lines.add(opStr);
       else
       end;
       opstr := '-----------';
       if blankChip then
       begin
         opstr := opstr +': Blank   Chip ';
       end;
       if chipSame  then
       begin
         opstr := opstr +': Chip == File ';
       end;
       opstr := opStr + ': -----------';

       case progMode of
         readData:       MData.lines.add(opStr);
         readProg:       MProg.lines.add(opStr);
         readFuses:      MFuses.lines.add(opStr);
       else
       end;

       Label5.caption := 'Finished';
       state := $1000;
     end;

     $40:
     begin
       case progMode of
         readData:  wrtCmd( RD_DATA_MEM  );
         readProg:  wrtCmd( RD_PRG_MEM  );
         readFuses: wrtCmd( RD_PRG_MEM  );
       else
       end;
       {wrtCmd( RD_PRG_MEM  );}
       { Do a read not sure why }
       opStr :='';
       case progMode of
           readData:  wrtCmd( RD_DATA_MEM  );
           readProg:  wrtCmd( RD_PRG_MEM  );
           readFuses: wrtCmd( RD_PRG_MEM  );
       else
       end;
       temp  := rdData;
       if temp <> $3FFF then BlankChip := FALSE;
       if hexData.data[ chipAddress ] <> temp then chipSame :=FALSE;

       for cnt1 := 0 to 7 do
       begin
         case progMode of
           readData:  wrtCmd( RD_DATA_MEM  );
           readProg:  wrtCmd( RD_PRG_MEM  );
           readFuses: wrtCmd( RD_PRG_MEM  );
         else
         end;
         temp  := rdData;
         if temp <> $3FFF then BlankChip := FALSE;
         if hexData.data[ chipAddress ] <> temp then chipSame :=FALSE;

         chipData.data[ chipAddress ] := temp;
         chipAddress := chipAddress +1 ;
         wrtCmd(INC_ADDR);
         opStr := opStr + ' ' + IntToHex( temp, 4 );
       end;

       opstr := IntToHex( cnt2,4 ) + ' : ' + opStr;
       case progMode of
         readData:       MData.lines.add(opStr);
         readProg:       MProg.lines.add(opStr);
         readFuses:      MFuses.lines.add(opStr);
       else
       end;
       cnt2  := cnt2  +8;
       case progMode of
         readData:   if chipAddress > $2100 + 63 then state := $41;
         readProg:   if chipAddress > $400 -1    then state := $41;
         readFuses:  if chipAddress > $2008-1    then state := $41;
       else
       end;
     end;

     $41:
     Begin
       opstr := '-----------';
       if blankChip = TRUE then opstr := opstr +': Blank   Chip ';
       if chipSame  = TRUE then opstr := opstr +': Chip == File ';
       opstr := opStr + ': -----------';

       case progMode of
         readData:       MData.lines.add(opStr);
         readProg:       MProg.lines.add(opStr);
         readFuses:      MFuses.lines.add(opStr);
       else
       end;
       Remove5VandVPP;
       state := $1000;
       Label5.caption := 'Finished';
     end;

     { bulk erase }
     $A00:            { bulk erase }
     begin

       wrtCmd( LD_CONF );    { $2000 }
       wrtData( $3FFF );
       wrtCmd(INC_ADDR);     { $2001 }
       wrtCmd(INC_ADDR);     { $2002 }
       wrtCmd(INC_ADDR);     { $2003 }

       wrtCmd(INC_ADDR);     { $2004 }
       wrtCmd(INC_ADDR);     { $2005 }
       wrtCmd(INC_ADDR);     { $2006 }
       wrtCmd(INC_ADDR);     { $2007 }
       wrtCmd( DIS_PROTECT1);
       wrtCmd( DIS_PROTECT2);
       wrtCmd( PROG );
       state:=$A01;
     end;
     $A01..$A07:
     begin

     end;

     $A08:
     begin
{       delay(DELAY_LONG);   }
       wrtCmd( DIS_PROTECT1);
       wrtCmd( DIS_PROTECT2);
       { State := $A09; }
       wrtCmd( LD_DATA_MEM );
       wrtData( $FFFF );
{       wrtCmd( ERASE_PROG ); }
       wrtCmd( ERASE_DATA );
       wrtCmd( PROG );

     end;

     $A0C:
     begin

       state := $1000;
     end;



     $A10:            { bulk erase }
     begin

       wrtCmd( LD_CONF );
       wrtData( $3FFF );
       wrtCmd(INC_ADDR);
       wrtCmd(INC_ADDR);
       wrtCmd(INC_ADDR);

       wrtCmd(INC_ADDR);
       wrtCmd(INC_ADDR);
       wrtCmd(INC_ADDR);
       wrtCmd(INC_ADDR);
       wrtCmd( DIS_PROTECT1);
       wrtCmd( DIS_PROTECT2);
       wrtCmd( PROG );
     end;

     $A18:
     begin
{       delay(DELAY_LONG);   }
       wrtCmd( DIS_PROTECT1);
       wrtCmd( DIS_PROTECT2);
       state := $A09;
     end;



     $B00: { Program Program Memory }
     begin
       Memo1.lines.add( ' ..Programming Program Memory...');
       chipAddress := $0000;
       wrtCmd( LD_PRG_MEM );
       wrtData( hexData.data[ chipAddress ] );
       state := state + 1;
       Memo1.lines.add( ' ..Programming Program Memory...');

       wrtCmd( PROG_NO_ERASE ); {  For 16F877 use NO_ERASE_PROG }
       state := $B01;
     end;

     $B01: { Program the rest}
     begin
{       wrtCmd( PROG_STOP);             }
       wrtCmd(RD_PRG_MEM);
       temp := rdData;
       if temp <> hexData.data[ chipAddress ] then
       begin
         Memo1.lines.add( 'Prog ' +intToHex(chipAddress,4)
                         +' Error:'+intToHex(temp,4)+'<>'
                         +intToHex(hexData.data[ chipAddress ],4) );
         Errors := TRUE;
       end else
       begin
         Label6.caption := 'Prog ' +intToHex(chipAddress,4)+' ok:'+intToHex(temp,4)+'=='+intToHex(hexData.data[ chipAddress ],4) ;
       end;
       { inc through memory that does not need programming }
       finished := false;
       While not finished do
       Begin
            wrtCmd( INC_ADDR );
            chipAddress := chipAddress + 1;
            if          ( hexData.data[ chipAddress ] <> $3FFF )
                        or ( chipAddress > $3FF ) then
            begin
              finished := true;
            end;
       end;



       state := $B01;
       if chipAddress > $3FF then
       begin
         state := $C00;
       end else
       begin
         wrtCmd( LD_PRG_MEM );
         wrtData( hexData.data[ chipAddress ] );
         state := state + 1;
         wrtCmd( PROG_NO_ERASE );
         state := $B01;
       end;
     end;

     $B04: { Program Data Memory}
     begin
       Memo1.lines.add( ' ..Programming Data Memory...');
       chipAddress := $2100;
       wrtCmd( LD_DATA_MEM );
       wrtData( hexData.data[ chipAddress ] );
       state := state + 1;
       wrtCmd( PROG_NO_ERASE );
       state := $B05;
     end;



     $B05: { Program }
     begin
       wrtCmd(RD_DATA_MEM);
       temp := rdData;
       if (temp AND $00FF) <> ( hexData.data[ chipAddress ] AND $00FF ) then
       begin
         Memo1.lines.add( 'Prog ' +intToHex(chipAddress,4)
                         +' Error:'+intToHex(temp,4)+'<>'
                         +intToHex(hexData.data[ chipAddress ],4) );
         Errors := TRUE;
       end else
       begin
         Label6.caption := 'Prog ' +intToHex(chipAddress,4)+' ok:'+intToHex(temp,4)+'=='+intToHex(hexData.data[ chipAddress ],4) ;
       end;

       wrtCmd( INC_ADDR );
       chipAddress := chipAddress + 1;

       state := $B05;
       if chipAddress > $2100+63 then
       begin
         state := $C00;
       end else
       begin
         wrtCmd( LD_DATA_MEM );
         wrtData( hexData.data[ chipAddress ] );
         state := state + 1;
         wrtCmd( PROG_NO_ERASE );
         state := $B05;
       end;
     end;

     $B08: { Program Configuration Memory}
     begin
       Memo1.lines.add( ' ..Programming Configuration Memory...');
       chipAddress := $2000;

       wrtCmd(  LD_CONF );
{       wrtData( $3FF1   ); {}
       wrtData( $3FFF   ); {}


       wrtCmd( LD_PRG_MEM );
       { The Buffer PIC holds back the ppCLKO for 1 ms }
       wrtData( hexData.data[ chipAddress ] );
       state := state + 1;
{       wrtCmd( PROG ); }
       wrtCmd( PROG_NO_ERASE );
       state := $B09;
     end;

     $B09: { Program }
     begin
       wrtCmd(RD_PRG_MEM);
       temp := rdData;
       if  chipAddress = $2006 then
       begin

         Label9.caption := 'Chip ID read as: ' +intToHex(temp,4) ;
       end;

       if ( temp <> hexData.data[ chipAddress ] ) and ( chipAddress <> $2006 ) then
       begin
         Memo1.lines.add( 'Prog ' +intToHex(chipAddress,4)
                         +' Error:'+intToHex(temp,4)+'<>'
                         +intToHex(hexData.data[ chipAddress ],4) );
         Errors := TRUE;
       end else
       begin
         Label6.caption := 'Prog ' +intToHex(chipAddress,4)+' ok:'+intToHex(temp,4)+'=='+intToHex(hexData.data[ chipAddress ],4) ;
       end;

       wrtCmd( INC_ADDR );
       chipAddress := chipAddress + 1;

       state := $B09;
       if chipAddress > $2008 then
       begin
         state := $C00;
       end else
       begin
         wrtCmd( LD_PRG_MEM );
         wrtData( hexData.data[ chipAddress ] );
         state := state + 1;
 {       wrtCmd( PROG ); }
         wrtCmd( PROG_NO_ERASE );
         state := $B09;
       end;
     end;


     { turn off Programming }
     $C00:
     Begin
       if Errors = TRUE then
              Memo1.Lines.Add('----Errors!!!-------')
       else
              Memo1.Lines.Add('--------------------');
       Remove5VandVPP;
       { do it again for data }
       state := 1;
       case progMode of
         progProg:  progMode := progData;
         progData:  progMode := progFuses;
       else
         state := $1000;
         if Errors = TRUE then
              Memo1.Lines.Add('----Errors!!!-------')
         else
              Memo1.Lines.Add('--- No Errors !  ---');
       Remove5VandVPP;
       end;
       Label5.caption := 'Finished';
     end;


     $1000:
     Begin
       MFuses.Visible := True;
       MData.Visible  := True;
       MProg.Visible  := True;

       state := 0;
       resetClk;
       resetData;
       Remove5VandVPP;
       Form1.Cursor :=  crDefault;
     End;


     { Other States }
     else
       if  state <> 0 then
       begin
         state  := state + 1;
       end;
     end;
end;

{ read Data }
procedure TForm1.Button6Click(Sender: TObject);
begin
  Errors   := FALSE;
  MData.lines.clear;
  progMode := readData;
  state    := 1;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Errors := FALSE;
  MFuses.lines.clear;
  progMode := readFuses;
  state    := 1;

end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := readFuses;
  state    := $1000;
end;

procedure TForm1.Button8Click(Sender: TObject);
var
   cnt : integer;
begin
  Errors := FALSE;
  Mfuses.Lines.Clear;
  Mfuses.Lines.add( '' );
  Mfuses.Lines[ 0 ] := IntToHex( $2000 , 4    )+' : ' ;
  opStr   :='$2000 :';
  for cnt := $2000+0 to $2000+7 do
  begin
    opStr := opStr + ' ' + IntToHex( chipData.data[cnt], 4 );
  end;
  Mfuses.Lines[0] := opStr;

  MData.Visible := False;
  MData.Lines.Clear;
  for cnt2:= 0 to ( 64 div 8 ) do
  begin
    MData.Lines.add( '' );
    opStr:= '';
    for cnt := $2100+cnt2*8  to $2100+cnt2*8+7 do
    begin
      opStr := opStr+IntToHex(chipData.data[cnt],4)+' ';
    end;
    MData.Lines[ cnt2 ] := IntToHex( $2100 + cnt2, 4 )+' : ' + opStr;
  end;
  MData.Visible := True;
  MProg.Visible := False;
  MProg.Lines.Clear;
  for cnt2:= 0 to ( $3FF div 8 ) do
  begin
    MProg.Lines.add( '' );
    opStr:= '';
    for cnt := $0000+cnt2*8  to $0000+cnt2*8+7 do
    begin
      opStr := opStr+IntToHex(chipData.data[cnt],4)+' ';
    end;
    MProg.Lines[ cnt2 ] := IntToHex( $0000+cnt2*8, 4 )+' : ' + opStr ;
  end;
  MProg.Visible := True;
end;

{ Program }
procedure TForm1.Button9Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := progProg ;
  state    := $1       ;
end;

{ Bulk Erase }
procedure TForm1.Button10Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := bulkEraseProg;
  state    := $1;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := progData ;
  state    := $1       ;

end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := progFuses ;
  state    := $1       ;

end;

procedure TForm1.ReopenLast1Click(Sender: TObject);
begin
    Memo1.Lines.Clear;
    Memo1.Lines.LoadfromFile(FileName);
    processMemo;
end;


procedure TForm1.processMemo;
var
   cnt, cnt2 : integer;
   lineStr   : string;
begin
    ReopenLast1.Enabled := True;
    Button2.Enabled     := True;
    for cnt := 0  to maxPicData -1 do
    begin
      HexData.data[cnt] := $3FFF ; { Unprogrammed state }
    end;

    for cnt := 0  to Form1.Memo1.Lines.count do
    begin
         ProcessLine(     HexData, Form1.Memo1.Lines[cnt]);
    end;

    Form1.Mfuses.Lines.add( '' );
    Form1.Mfuses.Lines[ 0 ] := IntToHex( $2000 , 4    )+' : ' ;
    for cnt := $2000+0 to $2000+7 do
    begin
      Form1.Mfuses.Lines[0] := Form1.Mfuses.Lines[0]+IntToHex(HexData.data[cnt],4)+' ';
    end;

    Form1.MData.Visible := False;
    for cnt2:= 0 to ( 64 div 8 ) do
    begin
      Form1.MData.Lines.add( '' );
      lineStr := '';
      for cnt := $2100+cnt2*8  to $2100+cnt2*8+7 do
      begin
        lineStr := lineStr + IntToHex( HexData.data[cnt], 4 )+' ';
      end;
      Form1.MData.Lines[cnt2] := IntToHex( $2100 + cnt2, 4 )+' : ' + lineStr ;
    end;
    Form1.MData.Visible := True;

    Form1.MProg.Visible := False;
    for cnt2:= 0 to ( $3FF div 8 ) do
    begin
      Form1.MProg.Lines.add( '' );
      lineStr := '';
      for cnt := $0000+cnt2*8  to $0000+cnt2*8+7 do
      begin
        lineStr := lineStr+IntToHex( HexData.data[cnt], 4 )+' ';
      end;
      Form1.MProg.Lines[ cnt2 ] := IntToHex( $0000 + cnt2 * 8, 4 )+' : ' + lineStr ;
    end;
    Form1.MProg.Visible := True;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
{     IniFile  := TIniFile.Create('ppdelp.Ini'); }
     IniFile  := TRegIniFile.Create('ppdelp.Ini');
     FileName := IniFile.ReadString('files','lastFile','');
     Caption  := FileName;
     if ( Filename <> '' ) then
     begin
       Memo1.Lines.Clear;
       Memo1.Lines.LoadfromFile(FileName);
       processMemo;
     end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     IniFile.WriteString('files','lastFile',FileName);
     IniFile.Free;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
{
 ; The XX only apply to the 16F877
;
;	Specials for turning on the +5 volts and 5 Vpp
;
;all Off			100000
;Vpp On				100001
;+5  On,Vpp Off			100010
;+5  On,Vpp On			100011
;
;
V5VVpp
}
  ConnectComPort;
{  resetClk;
  resetData;
  wrtCmd(  Voff );
 }
  wrtCmd(  $23 );

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     ReopenLast1Click( sender );
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   ret : boolean;
   a : TCOMSTAT;
   dwEvtMask: DWORD;
   lpModemStat: DWORD;
begin
  ConnectComPort;
  resetClk;
  resetData;


  wrtCmd(  $20 );
  wrtCmd(  $21 );
  wrtCmd(  $22 );
  wrtCmd(  $23 );
  wrtCmd(  V5VVpp );
  wrtCmd(  V5VVpp );

  wrtCmd(  $20 );

end;


procedure TForm1.Exit1Click(Sender: TObject);
begin
     Form1.Close
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  Form2.ShowModal;
end;

end.
